﻿using System.Threading;

namespace TestProject
{
    /// <summary>
    /// 비동기 샘플 데이터 소스
    /// </summary>
    public class AsyncSampleDataSource
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 저속 값
        /// </summary>
        private string slowerValue;

        /// <summary>
        /// 최저속 값
        /// </summary>
        private string slowestValue;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 고속 값 - FastValue

        /// <summary>
        /// 고속 값
        /// </summary>
        public string FastValue { get; set; }

        #endregion
        #region 저속 값 - SlowerValue

        /// <summary>
        /// 저속 값
        /// </summary>
        public string SlowerValue
        {
            get
            {
                Thread.Sleep(3000);

                return this.slowerValue;
            }
            set
            {
                this.slowerValue = value;
            }
        }

        #endregion
        #region 최저속 값 - SlowestValue

        /// <summary>
        /// 최저속 값
        /// </summary>
        public string SlowestValue
        {
            get
            {
                Thread.Sleep(5000);

                return this.slowestValue;
            }
            set
            {
                this.slowestValue = value;
            }
        }

        #endregion
    }
}